TTL equ " Wildcat EDO Accelerator [ wCatEDO ] Version 1.00   Copyright(C) 2023 ܂ "
InIPLW          equ     80h
code            segment
                assume cs:code,ds:code,es:code,ss:code
                org 100h  ; for MS-DOS .COM file
.186
start:
                jmp     start2
ProgramTitle    DB   0E5h,TTL,13,10,0
;align 2
SegTVRAM        DW      0A000h
ROW             DW      13
COLUMN          DW      0
cpuid486        DW      0
flagset         DB      0
ErrPmode        DB      041h," z86[hł͎sł܂.",13,10,0
ErrNoWC         DB      0C1h," {@Wildcat 82C594 `bvZbg@ł͂܂.",13,10,0
ErrFail         DB      0C1h," WildCatEDOݒ͊ɍsĂ悤ł. ~܂.",13,10,0
MsgDone         DB      0E1h," WildCatEDOݒs, READ܂.",13,10,0
.386p
start2:         xor     ax,ax
;               mov     cpuid486,ax
;               mov     flagset,al
                mov     es,ax
                mov     ax,es:[0486h]
                mov     cpuid486,ax
                call    CheckInDOS
                mov     dx,offset ProgramTitle
                call    putstring
                mov     ax,cpuid486
                and     ax,0F00h
                cmp     ax,0500h
                mov     dx,offset ErrNoWC
                jne     AbortProgram
                cld
                smsw    ax
                test    ax,1            ; ? Protected mode
                mov     dx,offset ErrPmode
                jnz     AbortProgram
                call    CheckWildcat
                mov     dx,offset ErrNoWC
                jc      AbortProgram
                call    WildCatEDO
                mov     dx,offset ErrFail
                jc      AbortProgram
                mov     dx,offset MsgDone
                
AbortProgram:   call    putstring
                call    DisplayWait
ExitProgram:    
                RET
;------------------------------------------------------------------
WildCatEDO      PROC   near
                mov     dx,0CF8h
                mov     eax,80000058h
                out     dx,eax
                mov     dx,0CFCh
                in      eax,dx          ;  5A ,  AH=59, AL=58
                mov     ebx,eax
                shr     ebx,16
                or      bl,bl
                jz      @f
                stc
                ret
        @@:
                or      al,al
                jz      Bank0Empty
                or      eax,00110000h   ; reg.5A=11h ; bit 7-4
Bank0Empty:     
                or      ah,ah
                jz      Bank1Empty
                or      eax,00140000h   ; reg.5A=15h
Bank1Empty:     
                out     dx,eax

                mov     dx,0CF8h
                mov     eax,80000074h
                out     dx,eax
                mov     dx,0CFCh
                in      ax,dx
                or      ah,ah
                jnz     @f
                mov     ah,21h
                out     dx,ax
        @@:     
                clc
                ret
WildCatEDO      ENDP
;------------------------------------------------------------------
CheckWildcat    PROC   near
                mov     dx,0CF8h
                mov     eax,80000000h
                out     dx,eax
                mov     dl,0FCh
                in      eax,dx
                cmp     eax,00071004h
                jne     @f
                clc
                ret
        @@:     stc
                ret
CheckWildcat    ENDP

;--------------------------------------------------------------------------
;       DisplayWait     
;--------------------------------------------------------------------------
DisplayWait     PROC    near
                push    ax
                push    cx
                mov     cx,0FEDCh
WaitDisplay:    out     5Fh,al
                out     5Fh,al
                out     5Fh,al
                out     5Fh,al
                out     5Fh,al
               loop     WaitDisplay
KeepDisplay:    mov     ah,02h
                int 18h
                test    al,1 ;  1 (bit0) = SHIFT_KEY
                jnz     KeepDisplay
                pop     cx
                pop     ax
                ret
DisplayWait     ENDP
;-------------------------------------------------

;===================================
include e:\asmlib\putstrj.inc
;-----------------------------------
putstring       PROC   near
                test    flagset,InIPLW
                jz      putstringDOS
                call    _puts
                ret
putstringDOS:   
                mov     bx,dx
putstring_ent:  inc     bx
                mov     dl,[bx]
                or      dl,dl
                jz      EndOfString
                mov     cl,10h
                mov     ah,00h          ; mov     ah,2
                int     0DCh            ; int     21h
                jmp     putstring_ent
EndOfString:    
                ret
putstring       ENDP

.186
CheckInDOS      PROC   near     ; ES=0
                mov     ax,cs
                cmp     ax,6000h        ; sZOgŔ
                je      ExecIPLW
                cmp     ax,7000h        ; sZOgŔIPLWUNI
                je      ExecIPLW
                ; IPLware DOSƌFƖ ̂QȊO͂
                mov     dl,es:[0501h]   ; nC]`FbN
                mov     ax,es:[21h*4+2] ; int 21h xN^`ȂDOS
                test    dl,8            ; nC]`FbN
                jz      @f
                mov     SegTVRAM,0E000h  ; VRAMR[ḧZOg
        @@:     
                cmp     ax,0060h        ; DOS̑݃ZOg 0060h͒ʏ
                je      ExecDOS
                cmp     ax,0436h        ; 436̂Ƃ?
                je      ExecDOS
                cmp     ax,0FFFFh       ; HMAɑ݂邩
                je      ExecDOS
ExecIPLW:       ; ȊÔƂ DOSIPLwareƌFĂ͏Ȃ
                or      flagset,InIPLW
                RET     ; IPLwareƔ肵Ė߂
ExecDOS:        
                nop
                nop
                nop
                RET     ; DOSƔ肵Ė߂
CheckInDOS      ENDP

code            ends
                end  start

